﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Hive.Contracts;
using HeuristicLab.Hive.Contracts.Interfaces;

namespace HeuristicLab.Hive.ExperimentManager {
  public class ServiceLocator {
    private static ServiceLocator instance = null;
    private WcfServicePool<IClientFacade> clientFacadePool = null;
    private WcfServicePool<IClientFacade> streamedClientFacadePool = null;

    public static ServiceLocator Instance {
      get {
        if (instance == null) {
          instance = new ServiceLocator();
        }
        return instance;
      }
    }

    public ServiceLocator() {  }

    public WcfServicePool<IClientFacade> ClientFacadePool {
      get {
        if (clientFacadePool == null) {
          clientFacadePool = new WcfServicePool<IClientFacade>("ClientHttpEndpoint");
        }
        return clientFacadePool;
      }
    }

    public WcfServicePool<IClientFacade> StreamedClientFacadePool {
      get {
        if (streamedClientFacadePool == null) {
          streamedClientFacadePool = new WcfServicePool<IClientFacade>("ClientTcpStreamedEndpoint");
        }
        return streamedClientFacadePool;
      }
    }
  }
}
